package org.apache.bcel.generic;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.ClassElementValue;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.ElementValue;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ElementValueGen;
import org.apache.bcel.generic.ObjectType;

public class ClassElementValueGen extends ElementValueGen {
  private final int idx;
  
  public ClassElementValueGen(ClassElementValue value, ConstantPoolGen cpool, boolean copyPoolEntries) {
    super(99, cpool);
    if (copyPoolEntries) {
      this.idx = cpool.addUtf8(value.getClassString());
    } else {
      this.idx = value.getIndex();
    } 
  }
  
  protected ClassElementValueGen(int typeIdx, ConstantPoolGen cpool) {
    super(99, cpool);
    this.idx = typeIdx;
  }
  
  public ClassElementValueGen(ObjectType t, ConstantPoolGen cpool) {
    super(99, cpool);
    this.idx = cpool.addUtf8(t.getSignature());
  }
  
  public void dump(DataOutputStream dos) throws IOException {
    dos.writeByte(getElementValueType());
    dos.writeShort(this.idx);
  }
  
  public String getClassString() {
    ConstantUtf8 cu8 = (ConstantUtf8)getConstantPool().getConstant(this.idx);
    return cu8.getBytes();
  }
  
  public ElementValue getElementValue() {
    return new ClassElementValue(getElementValueType(), this.idx, getConstantPool().getConstantPool());
  }
  
  public int getIndex() {
    return this.idx;
  }
  
  public String stringifyValue() {
    return getClassString();
  }
}
